// ----------------------------------
// -------- BASIC LED HELPER --------
// ----------------------------------

// basic lerp function
float return_lerp(float _s, int _target, int _time) {
  _s = _s + (( float(_target) - _s) / float(_time));
  return _s;

}

// --------------
// LED Object
// -------------
class aLED {
  private:
    byte pin;
    long ts = 0;
    int led_mode = 0; //0 manual / 1:sinpulse / 2:fading

  public:
    int brightness = 0; // current brightness
    float fade_target = 0; // where to fade?
    int fade_speed = 4;
    float pulse_speed = .004; // speed of pulse when in pulsemode
    int pulse_amplitude = 125;

    aLED(byte pin) {
      this->pin = pin;
      init();
    }

    void init() {
      pinMode(pin, OUTPUT);
    }

    void operateLED() {
      if (led_mode == 0) {

        // if in manual mode

      } else if (led_mode == 1) {

        // -----------  PULSE MODE
        brightness =  int((sin(millis() * pulse_speed) + 1) * pulse_amplitude * .5);

      } else if (led_mode == 2) {

        // -----------  FADING MODE
        brightness = int(return_lerp(brightness, fade_target, fade_speed));

      }

      analogWrite(pin, brightness);

    }

    void setMode(int _mode) {
      led_mode = _mode;
    }

};
